(**********************************************************)
(*                                                        *)
(*   Filename SPIEL.DCL                                   *)
(*                                                        *)
(*   TOOLBOX-Spezial III Echtzeitverarbeitung             *)
(*                                                        *)
(*   (C) TOOLBOX und Thomas Lang 1988                     *)
(*                                                        *)
(*   Dieses File enthlt die Deklarationen fr das im     *)
(*   Text beschriebene Spiel.                             *)
(*                                                        *)
(**********************************************************)

Const
   FolgenLaenge=6;            (* wie lang eine Folge wird *)

   FolgenDelta=35.0;          (* um diese Zeiteinheit *)
                              (* verkrzt sich fr die *)
                              (* nchste Folge zur Ver- *)
                              (* fgung stehende Zeit *)

   Folge1Zeit=700.0;          (* Zeit, die fr die 1. *)
                              (* Folge erlaubt ist *)

   TastenDelta=4.0;           (* DeltaZeit, in der die *)
                              (* Tastatur abgefragt wird *)

   MaxFolgen=15;              (* maximale Anzahl Folgen *)

   DruckBufLen=500;           (* Lnge des Buffers, der *)
                              (* Zeichen zum Drucken *)
                              (* enthlt *)

   DruckAnz=5;                (* Anzahl Character, die *)
                              (* auf einmal gedruckt *)
                              (* werden, falls Status Ok *)
                              (* und noch welche im *)
                              (* Buffer stehen *)

   DruckDeltaNoch=15.0;       (* DeltaZeit, in der wieder *)
                              (* versucht wird, etwas zu *)
                              (* drucken, falls noch was *)
                              (* im Buffer steht *)

   DruckDeltaNix=100.0;       (* DeltaZeit, in der nach- *)
                              (* geschaut wird, ob wieder *)
                              (* was im Druckerbuffer ist *)
                              (* und der Status ausgege- *)
                              (* ben wird, falls nichts *)
                              (* zu drucken war *)

   MinFrequenz=200;           (* Frequenz, mit der Tne *)
                              (* anfangen. Diese wird bei *)
                              (* jeder Folge bis zur *)
   MaxFrequenz=3000;          (* .. erhht, bis Eingabe *)
                              (* Ok oder Fehler *)

   FolgeSpalte=5;             (* Position, an der die *)
   FolgeZeile=6;              (* generierte Folge ausge- *)
                              (* geben wird *)

   EingabeSpalte=25;          (* Spalte, ab der eigene *)
                              (* Eingaben beginnen *)

   BewertungsSpalte=40;       (* Spalte, ab der Fehler *)
                              (* oder Ok angezeigt wird *)

   DruckSpalte=65;            (* Position, an der der *)
   DruckZeile=10;             (* DruckerStatus ausge- *)
                              (* geben werden soll *)

Var
   FolgenGenerier,            (* Flag, ob Folge generiert *)
                              (* werden soll (dann True) *)
                              (* oder TimeOut fr Folge *)
                              (* berwacht wird (=False) *)

   FolgeEingeben,             (* ob gerade eine Folge *)
                              (* eingegeben werden soll *)

   FolgeOk,                   (* ob bei Eingaben noch *)
                              (* keine Fehler sind, nur *)
                              (* fr aktuelle Folge *)

   DruckLeer,                 (* Ob DruckBuffer leer *)

   RestDrucken:Boolean;       (* ob nur noch der Rest des *)
                              (* DruckBuffers ausgedruckt *)
                              (* werden soll, dann ist *)
                              (* das Spiel beendet *)

   FolgeNummer,               (* die wievielte Folge an *)
                              (* der Reihe ist *)

   AnzahlEingaben,            (* wieviel Buchstaben rich- *)
                              (* tig eingegeben wurden *)

   RichtigBuchstaben,         (* Anzahl richtiger Buch- *)
                              (* staben bei Folgen, die *)
                              (* falsch waren *)

   RichtigUnvoll,             (* Anzahl richtiger Buch- *)
                              (* staben bei Folgen, die *)
                              (* unvollstndig waren *)

   AnzahlRichtig,             (* wieviel Folgen richtig *)
                              (* eingegeben wurden *)

   AnzahlUnvoll,              (* wieviel Folgen unvoll- *)
                              (* stndig waren *)

   DruckIn,                   (* Index um nchsten Char *)
                              (* in DruckBuffer zu *)
                              (* schreiben *)
   DruckOut,                  (* und aus DruckBuffer zu *)
                              (* holen *)

   DruckerNummer:Integer;     (* welcher Drucker, 0..2 *)

   FolgenZeit,                (* Zeit, die fr die nch- *)
                              (* ste Folge zum eingeben *)
                              (* zur Verfgung steht *)

   Frequenz,                  (* fr Sound *)

   TastenZeit,                (* Zeit, zu der die Tasta- *)
                              (* tur abgefragt werden *)
                              (* sollte *)

   SoundDelta:Real;           (* DeltaFrequenz, um die *)
                              (* Tne erhht werden *)

   Folge:Array[1..FolgenLaenge] Of Char;

   DruckBuffer:Array[1..DruckBufLen] Of Char;

   Procedure DruckChar(Ch:Char); Forward;
   Procedure DruckLn; Forward;
   Procedure DruckText(S:Str255); Forward;
   Procedure DruckInteger(I,Anzahl:Integer); Forward;
