(**********************************************************)
(*                                                        *)
(*   Filename DEBUG.DCL                                   *)
(*                                                        *)
(*   TOOLBOX-Spezial III Echtzeitverarbeitung             *)
(*                                                        *)
(*   (C) TOOLBOX und Thomas Lang 1988                     *)
(*                                                        *)
(*   Dieses File enthlt die fr den Debugger not-        *)
(*   wendigen Deklarationen.                              *)
(*                                                        *)
(**********************************************************)

Var
   SchirmLog,                 (* Flag, ob Logging auf *)
                              (* Bildschirm geht *)

   DruckerLog,                (* ebenso fr Drucker *)
   DateiLog:Boolean;          (* und in Datei *)

   LogFileName:FileName;      (* Name des LogFiles, falls *)
                              (* es benutzt wird *)

   LogFile:Text;              (* TextFile gengt hier *)

                              (* jetzt folgen Felder, *)
                              (* die angeben, ob eine *)
                              (* bestimmte Aufgabe mit *)
                              (* geloggt werden soll oder *)
                              (* nicht *)

   HochLog:Array[1..AnzahlHoch] Of Boolean;
                              (* fr Aufgaben mit hoher *)
                              (* Prioritt *)

   FifoLog:Array[1..VerschFifo] Of Boolean;
                              (* fr Aufgaben in Fifo *)

   PeriodicLog:Array[1..AnzahlPeriodic] Of Boolean;
                              (* fr periodische Aufgaben *)

                              (* Deklaration aller Pro- *)
                              (* zeduren und Funktionen *)
                              (* als sogenannte Forwards *)

Procedure InitDebug(Frage,Schirm,Drucker,Datei:Boolean;
                    Name:FileName); Forward;
Procedure PLogLn; Forward;
Procedure PLogText(S:Str255); Forward;
Procedure PLogInteger(I:Integer); Forward;
Procedure PLogReal(R:Real); Forward;
Procedure PLogHoch(Index:Byte); Forward;
Procedure PLogFifo(FifoNr:Byte;Param:Integer); Forward;
Procedure PLogPeriodic(Index:Byte); Forward;
Procedure PLogSchedul; Forward;
Procedure PLogPutHoch(HochNr:Byte); Forward;
Procedure PLogPutFifo(FifoNr:Byte;Param:Integer); Forward;
Procedure PLogPutPerAbs(PerNr:Byte;AbsZeit:Real); Forward;
Procedure PLogPutPerDelta(PerNr:Byte;DeltaZeit:Real);
                                                  Forward;
Procedure PLogInhaltHoch(S:Str255); Forward;
Procedure PLogInhaltFifo(S:Str255); Forward;
Procedure PLogInhaltPer(S:Str255); Forward;
