PROGRAM Freier_Fall;

{ Dieses Programm loest numerisch die Differenzialgleichung des Freien Fall's }
{ mit Beruecksichtigung des Luftwiderstandes. Dabei wird angenommen, dass der }
{ Luftwiderstand des fallenden Koerpers proportional zu v^2 ist. Zum Zeitpunkt}
{ t = 0 ist sowohl s = 0 als auch v = 0.                                      }

{ Die berechneten Daten werden in die Dateien FALL-S.DAT und FALL-V.DAT einge-}
{ schrieben und koennen dann mit Hilfe des Programm's GRPAHEN ausgewertet werden}

{ --------------------------------------------------------------------------- }
{               - Sprache     :  TURBO PASCAL 4.0 / 3.0 -                     }
{               - Copyright  (c) 1989  Heinz Hagemeyer  -                     }
{                      - & TOOLBOX International -                            }
{                                                                             }
{ --------------------------------------------------------------------------- }

USES CRT;   (* bei TURBO - PASCAL 4.0 *)

CONST    dt = 0.1  ;     { kleinste Zeiteinheit }
         g  = 9.81 ;     { Erdbeschleunigung    }
         tab= 20   ;     { Tabulator            }

VAR vd,sd   : Text ;
    s,                   { Weg                  }
    v,                   { Geschwindigkeit      }
    t,                   { Zeit                 }
    a,                   { Beschleunigung       }
   cw       : Real   ;   { Luftwiderstand       }
    ts,tn   : Integer;

{ --------------------------------------------------------------------------- }

PROCEDURE Anfangswerte (VAR Lw,s,v,t : Real);
BEGIN
     ClrScr;
     Write  ('Geben Sie den gewuenschten Luftwiderstand ein : ');
     ReadLn (Lw);

     s := 0;
     v := 0;
     t := 0;
END;

{ --------------------------------------------------------------------------- }

PROCEDURE Tabellenkopf;
VAR i : Integer;
BEGIN
     WriteLn  ('Ausgabe der berechneten Daten :');
     WriteLn;
     WriteLn  ('Zeit':tab,'Weg':tab,'Geschwindigkeit':tab);
     For i := 1 to 3*tab DO Write ('=');
     WriteLn;
END;

{ --------------------------------------------------------------------------- }

PROCEDURE Schreibe_in_Datei (VAR t : Text; x,y : Real);

CONST Klingel = #07;

BEGIN
     {$I-}                     { Fehlerueberwachung aus }
          WriteLn (t,x,y );
     {$I+}                     { und wieder ein         }

     IF IOResult <> 0 THEN
     BEGIN
          GotoXY (1,1);
          Write  (Klingel,'Diskette voll, Programm wird abgebrochen !');
          HALT;
     END;
END;

{ --------------------------------------------------------------------------- }

PROCEDURE Schreibe;
BEGIN
     Schreibe_in_Datei (vd,t,v) ;
     Schreibe_in_Datei (sd,t,s) ;
     WriteLn (t:tab:2,s:tab:2,v:tab:2);
END;

{ --------------------------------------------------------------------------- }

BEGIN    { Main }

     Assign  (vd,'fall-v.dat');     { Vorbereitung der Dateien         }
     Assign  (sd,'fall-s.dat');
     Rewrite (vd);                  { Oeffne Datei zum Schreiben       }
     ReWrite (sd);

     Anfangswerte (cw,s,v,t);
     Tabellenkopf;
     Schreibe;                      { Anfangswerte in Datei ausgeben   }

     FOR ts := 0 TO 5 DO            {  Fuer jede Sekunde               }
     BEGIN
          FOR tn := 1 TO Round (1 / dt)  DO
          BEGIN
               t := ts + dt * tn          ;    { Werte berechnen       }
               a := g  - cw * sqr(v)      ;
               v := v  + a  * dt          ;
               s := s  + v  * dt          ;

               Schreibe                   ;    { und in Datei ausgeben }

          END;
     END;

     Close (sd);                    { Dateien schliessen               }
     Close (vd);
END.
