(* ------------------------------------------------------------------------- *)
(*                               PROBABIL.PAS                                *)
(*                 Integration der Normalverteilungsfunktion                 *)
(* ------------------------------------------------------------------------- *)

PROGRAM Probability;

USES
  NumInt;

VAR
  Mean, SDev, Delta, P, eps : FLOAT;
  Decimals                  : BYTE;
  N                         : LONGINT;

{$F+}
FUNCTION rho(x : FLOAT) : FLOAT;
  (* die Dichtefunktion *)
BEGIN
  rho := 1/(SDev*Sqrt(2*Pi)) * Exp(-0.5*Sqr((x-Mean)/SDev))
END;
{$F-}

BEGIN
  Write(^M^J'Bitte Daten eingeben:'^M^J);
  Write(^M^J'Mittelwert:   = '); Read(Mean);
  Write(    'Streuung:     = '); Read(SDev);
  Write(    'Abweichung:   = '); Read(Delta);
  Write(^M^J'Genauigkeit der Berechnung in Dezimalstellen: ');
  Read(Decimals);
  eps := Exp(-Abs(Decimals)*Ln(10));
  N := Succ(Trunc((2*Delta)/SDev * Sqrt(Exp(-1.5)/(Sqrt(2*pi)*eps))));
  WriteLn('--> ', N, ' Sttzstellen!'^M^J);
  P := 100 * Trapezoid(@rho, Mean-Delta, Mean+Delta, N);
  WriteLn('P(', Mean-Delta:0:2, '  X  ',
                Mean+Delta:0:2, ') = ', P:0:1, '%'^M^J^M^J);
END.
