/* intprot.h
Prototypen der verwendeten Funktionen des Interpreters.
(c) 1990 Michael Beising & TOOLBOX
*/

/* error.c */
void fatal_error (char *FehlerMeldung);
void serror (char      *FehlerMeldung);
void ResetError(void);

/* ibefehle.c */

int		FindInsPos (int LineNumber,PRGZEILE	**InsPos);

int crun(void);
int cset(void);
int cdruck(void);
int cif (void);
int cload(void);
int csave(void);
int cgoto(void);
int cende(void);
int cexit(void);
int cmerke(void);
int clist (void);
int cneu(void);
int chilfe(void);
int czeig(void);
int csetfarbe(void);
int cloesch(void);
int cpause(void);
int cdos(void);
int csbild(void);
int crbild(void);
int clese(void);
int ciftaste(void);
int cbox(void);
int cattribut(void);
int cinfo(void);
int cpiep(void);
int cgerald(void);
int ccommands(void);

/* string.c, util2.c */
int cstrdef(void);
int cstrset(void);
int cbegin(void);
int cend(void);
int creadln(void);
int cgosub(void);
int citostr(void);
int cstrtoi(void);
int crandom(void);
int crandomize(void);
int dogosub(int LineNumber);
void SetVarInt(char *name,long wert);
int GetIntegerParam(long *wert);  
int GetStringParam(char **wert);  
int GetStrVarParam(char **wert);  
int GetNumbVarParam(long **wert);  
int GetVarNameParam(char **name);  
int GetSonderZeichen(char c);

int DefVarInt (char *name, long val);
int DefVarStr (char *name, int size);
int SetVarStr2(char *name,char *str);
int SetVarStr(char *name,char *str);

/* array.c */

int cDefArray(void);
int cSetArrayElem(void);
int cGetArrayElem(void);

/* Editor und Windows */
int cneuedit(void);	
int cwindow(void);	
int cclosewindow(void);	
int csetcursor(void);	
int csetfkey(void);	
int csetlinebuf(void);	
int cwindowfirst(void); 
int cinitedit(void);
int cendedit(void);
int ceditorproc(void);
int cshoweditor(void);
int cinsertstring(void);
int cedfunction(void);  
int cNewWinKoor(void);
int cResizeWin(void);
int cMoveWin(void);
int cGetEdWord(void);
int cGetEdString(void);
int cWinReadStr(void);
int cWinMessage(void);
int cReadKey(void);
int cAuswahl(void);
int cWinWrite(void);

/* Prprozessor und TXL-Datenbank-Befehle */
void TransformFile(char *source, char *dest);
int cdummy(void);
int cGotoBegin(void);
int cGotoEnd(void);
int cGoBackward(void);
int cGoForward(void);
int cGoTo(void);
int cGoToNr(void);
int cCloseFile(void);
int cMakeTree(void);
int cMarkCurrent(void);
int cUnMarkAll(void);
int cDelTree(void);
int cDelMarked(void);
int cListTree(void);
int cStopSearch(void);
int cGefundenOK(void);
int cSearchDB(void);
int cSearchTree(void);
int cDurchsucheTree(void);
int cdefDB(void);
int copenDB(void);
int ccreateDB(void);
int cWriteDB(void);
int cReadDB(void);
int cAddDB(void);
int cReadDBFormat(void);

/*** Men und Stack ***/
int cMenue(void);
int cpush(void);
int cpop(void);

/* inspglin.c */

void InsIntLine (void);
int  DelLine (int LineNumber);

/* interp.c */

void InterAct (void);
int  InterpLine (void);
int  DoProgram (void);
int     MakeToken (void);

/* intutil.c */

void   ShowLine (PRGZEILE *FindZeile);
VAR *  IsVariable (char *Name);
int    SetVar (VAR *Wert);
void   ReadValue (VAR *Wert);
void   SetValue (VARDEF *Wert,VARDEF *NewVar,unsigned char Type, int neu);
void   GetValue (VARDEF *Wert,VARDEF *NewVar,unsigned char Type);
int    CmpVar (void);
void   ReadComp (void);
int    Compare (void);
void   PrintVar (char *Name);
int    CalcExpression (VAR *Result);
void   SetResultValue (VAR *Result);
void   PushExp (void);
void   CalcResult (void);
EXPDEF *PopExp (void);
void   ClearProg (void);

/* scan.c */

int    Scan (void);
void   NoSkipChar (void);
void   SkipChar (void);
void   GetGeklammert (char *buffer);

/* textbuf.c */

int    ReadProg (void);
int    WriteProg (void);
void   SetFileName (char *FName);
char   *GetFileName (void);

/* Ende des Files INTPROT.H */
