/* intprot.h
Prototypen der verwendeten Funktionen des Interpreters.
(c) 1990 Michael Beising & TOOLBOX
*/

/* error.c */
void fatal_error (char *FehlerMeldung);
void serror (char      *FehlerMeldung);
void ResetError (void);

/* ibefehle.c */

int		FindInsPos (int LineNumber,PRGZEILE	**InsPos);

int crun(void);
int ccommands(void);
int cset(void);
int cdruck(void);
int cif (void);
int cload(void);
int csave(void);
int cgoto(void);
int cende(void);
int cexit(void);
int cmerke(void);
int clist (void);
int cneu(void);
int ctrcon(void);      /* Tracer an */
int ctrcoff(void);     /* Tracer aus */
int cwdog(void);       /* Tracer einmal aktiv */
int creadvar(void);    /* Variable einlesen */
int ccopy(void);       /* in String kopieren */
int cins(void);        /* in String einfgen */
int cdel(void);        /* Teil des String lschen */

/* inspglin.c */

void InsIntLine (void);
int  DelLine (int LineNumber);

/* interp.c */

void InterAct (void);
int  InterpLine (void);
int  DoProgram (void);
int  MakeToken (void);

/* itracer.c */

void  Trace(void);     /* Hilfe zur Fehlersuche */

/* intutil.c */

void   ShowLine (PRGZEILE *FindZeile);
VAR *  IsVariable (char *Name);
int    SetVar (VAR *Wert);
void   ReadValue (VAR *Wert);
void   SetValue (VARDEF *Wert,VARDEF *NewVar,unsigned char Type);
void   GetValue (VARDEF *Wert,VARDEF *NewVar,unsigned char Type);
int    CmpVar (void);
int    ReadComp (int *Op);
int    Compare (int Op);
void   PrintVar (char *Name);
int    CalcExpression (VAR *Result);
void   SetResultValue (VAR *Result);
void   PushExp (void);
void   CalcResult (int Op, int Ops);
EXPDEF *PopExp (void);
void   ClearProg (void);

/* neue Funktionen in intutil */

void    Expression (void);     /* berechne Ausdruck */
void    Term (void);
void    Faktor (void);
int     TestFunc (int *func);  /* Funktionsname z.B. sqr ? */

void    NewString (VARDEF *Var,size_t len);
void    MinMax (int Ops, int minmax);  /* min und max */
void    Length (void);     /* Stringlnge */
void    Left (void);       /* Zeichen aus linkem Stringteil */
void    Right (void);      /*   "      "  rechtem     "     */
void    Mid (void);        /*   "      "  der Mitte         */
void    InStr(void);       /* String enthalten ?            */

int TestComma (void);      /* Komma gescannt ?              */
int GetStringVar (VAR **str); /* Stringvariable gescannt ?  */
int GetLong (long *val);   /* Ausdruck scannen und als long liefern */

/* scan.c */

int    Scan (void);
void   NoSkipChar (void);
void   SkipChar (void);
void   GetGeklammert (char *buffer);

/* textbuf.c */

int    ReadProg (void);
int    WriteProg (void);
void   SetFileName (char *FName);
char   *GetFileName (void);

/* Ende des Files INTPROT.H */
